diff -Naur rp-pppoe-3.3.org/scripts/adsl-connect rp-pppoe-3.3.new/scripts/adsl-connect
--- rp-pppoe-3.3.org/scripts/adsl-connect	Thu Jan  1 01:00:00 1970
+++ rp-pppoe-3.3.new/scripts/adsl-connect	Thu Mar 13 11:49:21 2003
@@ -0,0 +1,127 @@
+#!/bin/sh
+
+# Based on adsl-connect of rp-pppoe.
+# Modified by Christian Berger (c.berger@tu-braunschweig.de).
+
+# Paths to programs
+IFCONFIG=/sbin/ifconfig
+PPPD=/usr/sbin/pppd
+PPPOE=/usr/sbin/pppoe
+LOGGER="/usr/bin/logger -t `/usr/bin/basename $0`"
+
+# Set to "C" locale so we can parse messages from commands
+LANG=C
+export LANG
+
+CONFIG=/etc/ppp/pppoe.conf
+
+if test ! -f "$CONFIG" -o ! -r "$CONFIG" ; then
+    echo "$0: Cannot read configuration file '$CONFIG'" >& 2
+    exit 1
+fi
+
+. $CONFIG
+
+PPPOE_PIDFILE="$PIDFILE.pppoe"
+PPPD_PIDFILE="$PIDFILE.pppd"
+
+# Check that config file is sane
+if test "$USER" = "" ; then
+    echo "$0: Check '$CONFIG' -- no setting for USER" >& 2
+    exit 1
+fi
+if test "$ETH" = "" ; then
+    echo "$0: Check '$CONFIG' -- no setting for ETH" >& 2
+    exit 1
+fi
+
+PPPD_PID=0
+
+# MTU of Ethernet card attached to modem MUST be 1500. 
+$IFCONFIG $ETH up mtu 1500
+
+if test "$SYNCHRONOUS" = "yes" ; then
+	PPPOE_SYNC=-s
+	PPPD_SYNC=sync
+else
+	PPPOE_SYNC=""
+	PPPD_SYNC=""
+fi
+
+if test -n "$ACNAME" ; then
+    ACNAME="-C $ACNAME"
+fi
+
+if test -n "$SERVICENAME" ; then
+    SERVICENAME="-S $SERVICENAME"
+fi
+
+if test "$CLAMPMSS" = "no" ; then
+	CLAMPMSS=""
+else
+	CLAMPMSS="-m $CLAMPMSS"
+fi
+
+# If DNSTYPE is SERVER, we must use "usepeerdns" option to pppd.
+if test "$DNSTYPE" = "SERVER" ; then
+	USEPEERDNS=yes
+fi
+
+if test "$USEPEERDNS" = "yes" ; then
+	USEPEERDNS="usepeerdns"
+else
+	USEPEERDNS=""
+fi
+
+# Backward config file compatibility
+if test "$DEMAND" = "" ; then
+	DEMAND=no
+fi
+
+if test "$DEMAND" = "no" ; then
+	DEMAND=""
+else
+	DEMAND="demand persist idle $DEMAND 10.112.112.112:10.112.112.113 ipcp-accept-remote ipcp-accept-local connect true noipdefault ktune"
+fi
+
+if test "$DEFAULTROUTE" = "yes" ; then
+    DEFAULTROUTE="defaultroute"
+else
+    DEFAULTROUTE=""
+fi
+
+# Standard PPP options we always use
+PPP_STD_OPTIONS="$PLUGIN_OPTS noipdefault noauth default-asyncmap $DEFAULTROUTE hide-password nodetach $USEPEERDNS mtu 1492 mru 1492 noaccomp noccp nobsdcomp nodeflate nopcomp novj novjccomp user $USER lcp-echo-interval $LCP_INTERVAL lcp-echo-failure $LCP_FAILURE $PPPD_EXTRA"
+
+# Jigger DNS if required...
+if test "$DNSTYPE" = "SPECIFY" ; then
+    # Sorry, dude...
+    rm -f /etc/resolv.conf
+    echo "nameserver $DNS1" > /etc/resolv.conf
+    if test -n "$DNS2" ; then
+	echo "nameserver $DNS2" >> /etc/resolv.conf
+    fi
+fi
+
+# PPPoE invocation
+PPPOE_CMD="$PPPOE -p $PPPOE_PIDFILE -I $ETH -T $PPPOE_TIMEOUT -U $PPPOE_SYNC $CLAMPMSS $ACNAME $SERVICENAME $PPPOE_EXTRA"
+
+echo $$ > $PIDFILE
+
+while [ true ] ; do
+    $PPPD pty "$PPPOE_CMD" \
+	    $PPP_STD_OPTIONS \
+	    $DEMAND \
+	    $PPPD_SYNC &
+    echo "$!" > $PPPD_PIDFILE
+
+    wait
+
+    # Re-establish the connection
+    $LOGGER -p daemon.notice \
+        "ADSL connection lost; attempting re-connection."
+
+    # Wait a bit in case a problem causes tons of log messages :-)
+    sleep 5
+done
+
diff -Naur rp-pppoe-3.3.org/src/Makefile rp-pppoe-3.3.new/src/Makefile
--- rp-pppoe-3.3.org/src/Makefile	Thu Jan  1 01:00:00 1970
+++ rp-pppoe-3.3.new/src/Makefile	Thu Mar 13 20:48:50 2003
@@ -0,0 +1,76 @@
+# Makefile
+#
+# Makefile for Roaring Penguin's Linux user-space PPPoE client.
+#
+# Modified for compiling rp-pppoe-3.3 against uclibc for SEGA Dreamcast
+# by Christian Berger.
+#
+# Copyright (C) 2000 Roaring Penguin Software Inc.
+#
+# This program may be distributed according to the terms of the GNU
+# General Public License, version 2 or (at your option) any later version.
+#
+# $Id: Makefile.in,v 1.62 2001/09/14 19:18:43 dfs Exp $
+#***********************************************************************
+
+# Version is set ONLY IN THE MAKEFILE!  Don't delete this!
+VERSION=3.3
+
+DEFINES= 
+PREFIX=/usr/local
+install=/usr/bin/install -c
+install_dir=/usr/bin/install -c -d
+
+
+# Program paths
+PPPOE_PATH=$(sbindir)/pppoe
+PPPD_PATH=/usr/sbin/pppd
+
+CROSS=
+CC= $(CROSS)cc
+STRIP= $(CROSS)strip --remove-section=.note --remove-section=.comment
+
+PATHS='-DPPPOE_PATH="$(PPPOE_PATH)"' '-DPPPD_PATH="$(PPPD_PATH)"' 
+
+CFLAGS= -Os -Wall -Wstrict-prototypes -ansi -pedantic $(DEFINES) $(PATHS)
+TARGETS=pppoe
+
+all: $(TARGETS)
+	@echo ""
+	@echo "Type 'make install' as root to install the software."
+
+pppoe: pppoe.o if.o debug.o common.o ppp.o discovery.o
+	$(CC) -o pppoe pppoe.o if.o debug.o common.o ppp.o discovery.o
+	$(STRIP) pppoe
+
+pppoe.o: pppoe.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o pppoe.o pppoe.c
+
+discovery.o: discovery.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o discovery.o discovery.c
+
+ppp.o: ppp.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o ppp.o ppp.c
+
+if.o: if.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o if.o if.c
+
+common.o: common.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o common.o common.c
+
+debug.o: debug.c pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o debug.o debug.c
+
+relay.o: relay.c relay.h pppoe.h
+	$(CC) $(CFLAGS) '-DVERSION="$(VERSION)"' -c -o relay.o relay.c
+
+install: all
+	-mkdir -p $(PREFIX)/sbin
+	$(install) -m 755 pppoe $(PREFIX)/sbin
+	$(install) -m 755 ../scripts/adsl-connect $(PREFIX)/sbin
+
+.PHONY: clean
+
+clean:
+	-rm -f *.o core *.so *.a pppoe pppoe-server pppoe-sniff pppoe-relay
+
